import * as React from 'react';
/**
 * The `Toast` component is a rudimentary way to display a message to the user.
 * This message should be short lived and not require user interaction.
 * For example, displaying the current connection state like `ConnectionStateToast` does.
 *
 * @example
 * ```tsx
 * <Toast>Connecting...</Toast>
 * ```
 * @public
 */
export declare function Toast(props: React.HTMLAttributes<HTMLDivElement>): React.JSX.Element;
//# sourceMappingURL=Toast.d.ts.map