import type { Participant } from 'livekit-client';
import { ConnectionQuality } from 'livekit-client';
/** @public */
export interface ConnectionQualityIndicatorOptions {
    participant?: Participant;
}
/**
 * The `useConnectionQualityIndicator` hook provides props for the `ConnectionQualityIndicator` or your custom implementation of it component.
 * @example
 * ```tsx
 * const { quality } = useConnectionQualityIndicator();
 * // or
 * const { quality } = useConnectionQualityIndicator({ participant });
 * ```
 * @public
 */
export declare function useConnectionQualityIndicator(options?: ConnectionQualityIndicatorOptions): {
    className: "lk-connection-quality";
    quality: ConnectionQuality;
};
//# sourceMappingURL=useConnectionQualityIndicator.d.ts.map